<template>
    <app-dialog title="Create storage" dialog-name="createStorage" cancellable>

        <template slot="dialog-content">
            <v-form>
                <v-select
                    label="Path type"
                    :items="pathTypeItems"
                    v-model="pathType"
                />

                <v-select
                    label="Relative Directory"
                    :items="relativeStorageNameItems"
                    v-model="relativeStorageName"
                    v-show="pathType === 'relative'"
                />

                <v-text-field
                    placeholder="Name your storage"
                    hint='Ex. "My Company Name"'
                    v-model="storageName"
                />

                <v-text-field
                    v-if="pathType === 'absolute'"
                    append-icon="mdi-folder-plus-outline"
                    placeholder="Path to storage folder"
                    @keydown="handlePathToStorageKeydown"
                    @click="handlePathToStorageClick"
                    v-model="pathToStorage"
                />

                <v-autocomplete
                    v-else
                    prepend-icon="mdi-folder-plus-outline"
                    placeholder="Select or create a new folder"
                    :label="`Select a folder in ${relativeStorageNameLabel}`"
                    @keydown="handlePathToRelStorageKeydown"
                    v-model="pathToRelStorage"
                />

                <v-checkbox v-model="markAsDefault" label="Mark as default storage" />
            </v-form>
        </template>

        <template slot="dialog-actions">
            <v-btn
                color="success"
                text
                @click="handleCreateBtnClick"
                :disabled="isCreateBtnDisabled"
            >
                Create
            </v-btn>
        </template>

    </app-dialog>
</template>

<script lang="ts">
import { computed, defineComponent, ref, Ref } from "@vue/composition-api";
import { useContents, useDialogs, useSettings, useTreeView } from "@/compositions";
import { openDirDialog } from "@/ipc/openDirDialog";
import { lowerFirst } from 'lodash';
import { AppStorage } from "@/ts";
import { createStorage } from "@/ipc/createStorage";
import AppDialog from "@/components/dialogs/AppDialog.vue";

export default defineComponent({
    name: "CreateStorageDialog",
    components: { AppDialog },
    setup() {
        const appDialogs = useDialogs().getDialogs();

        const pathType: Ref<'relative'|'absolute'> = ref('absolute');
        const relativeStorageName: Ref<string> = ref('user_home');
        const storageName: Ref<string> = ref('');
        const pathToStorage: Ref<string> = ref('');
        const pathToRelStorage: Ref<string|undefined> = ref();
        const markAsDefault: Ref<boolean> = ref(false);

        const pathTypeItems = [
            // { text: 'Relative', value: 'relative' },
            { text: 'Absolute', value: 'absolute' }
        ];

        const relativeStorageNameItems = [
            { text: 'Your Home folder', value: 'user_home' },
            { text: 'OnMyMark directory', value: 'electron' },
            { text: 'Your Documents folder', value: 'documents' },
            { text: 'Your Desktop', value: 'desktop' },
        ];

        const relativeStorageNameLabel = computed(() => {
            const selected = relativeStorageNameItems.filter((item) => {
                return item.value === relativeStorageName.value;
            });

            return lowerFirst(selected[0].text);
        });

        const hasErrors = computed(() => {
            return false;
        });

        const opeStorageDialogue = async () => {
            const dirSelectionResponse = await openDirDialog(relativeStorageName.value) as { dir: string[]|undefined };
            const dir = dirSelectionResponse.dir && dirSelectionResponse.dir.length && dirSelectionResponse.dir[0];
            pathToStorage.value = dir || '';
        }

        const handlePathToStorageClick = async () => {
            await opeStorageDialogue();
        }

        const handlePathToStorageKeydown = async (e: KeyboardEvent) => {
            e.preventDefault();
            await opeStorageDialogue();
        }

        const handlePathToRelStorageKeydown = (e: KeyboardEvent) => {
            // eslint-disable-next-line no-console
            console.log(e); // todo: implement method and remove console lod
        }

        const handleDirInput = (e: KeyboardEvent) => {
            e.preventDefault();
        }

        /**
         * Creates a storage and hides the dialog on click.
         * @todo Handle possible errors in creating storage.
         * @todo Show confirmation message.
         */
        const handleCreateBtnClick = async () => {
            const newStorage: AppStorage = {
                name: storageName.value,
                type: pathType.value,
                root: pathType.value === 'absolute' ? '' : relativeStorageName.value,
                path: pathToStorage.value,
                default: markAsDefault.value
            }

            const response = await createStorage(newStorage);

            useDialogs().deActivateDialog('createStorage');

            if (!response) return;

            useSettings().setStorage(response.storage);

            const appStorage = useSettings().getStorage;

            appStorage.value.some((storage: AppStorage) => {
                if (storage.path !== response.newStorage.path) return false;

                useContents().setCurrentStorage(storage);

                return true;
            });

            await useTreeView().updateTreeContents();

            const rootDir = useTreeView().getRoot.value;

            useTreeView().selectFirstFile(rootDir);
        }

        const isCreateBtnDisabled = computed(() => {
            return hasErrors.value ||
                    !pathType.value ||
                    !storageName.value ||
                    !pathToStorage.value;
        });

        return {
            handlePathToStorageClick,
            handlePathToStorageKeydown,
            handleDirInput,
            handlePathToRelStorageKeydown,
            handleCreateBtnClick,
            appDialogs,
            pathType,
            relativeStorageName,
            pathToStorage,
            pathToRelStorage,
            storageName,
            markAsDefault,
            pathTypeItems,
            relativeStorageNameItems,
            relativeStorageNameLabel,
            isCreateBtnDisabled
        }
    }
});
</script>

<style scoped>

</style>